﻿using DBDraft.Model;
using Syncfusion.XForms.DataForm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;
using DBDraft.Helper;

namespace DBDraft
{
    public class AddressItemPage : ContentPage
    {
        SfDataForm dataForm;
        private AddressItem _reportItem;
        public AddressItemPage(AddressItem reportItem)
        {
            _reportItem = reportItem;
            _reportItem.PropertyChanged += _reportItem_PropertyChanged;
            dataForm = new SfDataForm();
            dataForm.VerticalOptions = LayoutOptions.FillAndExpand;
            dataForm.HorizontalOptions = LayoutOptions.FillAndExpand;
            dataForm.DataObject = _reportItem;
            dataForm.BindingContext = BindingContext;
            dataForm.CommitMode = CommitMode.LostFocus;
            dataForm.AutoGeneratingDataFormItem += DataForm_AutoGeneratingDataFormItem;

            //Segment Editor
            dataForm.RegisterEditor("SaveTo", "Segment");
            dataForm.RegisterEditor("SaveToAlt", "Segment");


            StackLayout stackLayout = new StackLayout();
            stackLayout.VerticalOptions = LayoutOptions.FillAndExpand;
            stackLayout.HorizontalOptions = LayoutOptions.FillAndExpand;

            stackLayout.Children.Add(dataForm);
            
            Content = stackLayout;
        }

        private async void _reportItem_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            await App.ReportDatabase.UpdateItemAsync((AddressItem)this.dataForm.DataObject);
        }


        private void DataForm_AutoGeneratingDataFormItem(object sender, AutoGeneratingDataFormItemEventArgs e)
        {
            var type = new DataFormCheckBoxItem();
            try
            {
                if (e.DataFormItem.GetType() == type.GetType())//As none of our checkboxes need three states set IsThreeState for ALL checkboxes to false
                {
                    type = e.DataFormItem as DataFormCheckBoxItem;
                    type.IsThreeState = false;
                }
            }catch { };
            if (e.DataFormItem != null && e.DataFormItem.Name == "SaveToAlt")
            {
                var altType = new List<string>();
                altType.Add("SimAlt");
                altType.Add("PhoneAlt");
                (e.DataFormItem as DataFormSegmentItem).ItemsSource = altType;
            }
        }
    }
}