﻿using System.IO;
using System.Collections.Generic;
using System.Threading.Tasks;
using SQLite;
using DBDraft.Model;

namespace DBDraft.Data
{
    public class AddressDatabase
    {
        readonly SQLiteAsyncConnection database;

        public AddressDatabase(string dbPath)
        {
            if (!File.Exists(dbPath))//if database does not exist create the connection, the table, and add some data
            {
                database = new SQLiteAsyncConnection(dbPath);
                CreateTableAsync();
                AddressItem r;
                r = new AddressItem { Name = "George", City = "Town 1", ID = 0, Complete = true, ZIP = 78023, SaveToId = 0, SaveToAlt = "SimAlt"};
                InsertItemAsync(r);
                r = new AddressItem { Name = "Jim", City = "Town 2", ID = 1, Complete = true, ZIP = 78023, SaveToId = 0, SaveToAlt = "SimAlt" };
                InsertItemAsync(r);
                r = new AddressItem { Name = "Stacey", City = "Town 3", ID = 2, Complete = true, ZIP = 78023, SaveToId = 1, SaveToAlt = "PhoneAlt" };
                InsertItemAsync(r);
            }
            else
            {
                database = new SQLiteAsyncConnection(dbPath);
            }
        }
        public Task<int> CreateTableAsync()
        {
            database.CreateTableAsync<AddressItem>().Wait();
            return null;
        }
        public Task<List<AddressItem>> GetItemsAsync()
        {
            return database.Table<AddressItem>().ToListAsync();
        }

        public Task<AddressItem> GetItemAsync(int id)
        {
            return database.Table<AddressItem>().Where(i => i.ID == id).FirstOrDefaultAsync();
        }

        public Task<int> UpdateItemAsync(AddressItem item)
        {
            return database.UpdateAsync(item);            
        }
        public Task<int> InsertItemAsync(AddressItem item)
        {
            return database.InsertAsync(item);
        }
    }
}

