﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Syncfusion.XForms.DataForm;
using Xamarin.Forms;
using DBDraft.Model;

namespace DBDraft
{
    public class MainPage : ContentPage
    {
        ListView listView;

        public MainPage()
        {
            Title = "ReportDatabase Test";

            listView = new ListView
            {
                Margin = new Thickness(20),
                ItemTemplate = new DataTemplate(() =>
                {
                    var label = new Label
                    {
                        VerticalTextAlignment = TextAlignment.Center,
                        HorizontalOptions = LayoutOptions.StartAndExpand
                    };
                    label.SetBinding(Label.TextProperty, "Name");

                    var stackLayout = new StackLayout
                    {
                        Margin = new Thickness(20, 0, 0, 0),
                        Orientation = StackOrientation.Horizontal,
                        HorizontalOptions = LayoutOptions.FillAndExpand,
                        Children = { label }
                    };

                    return new ViewCell { View = stackLayout };
                })
            };
            listView.ItemSelected += async (sender, e) =>
            {
                if (e.SelectedItem != null)
                {
                    await Navigation.PushAsync(new AddressItemPage((AddressItem)e.SelectedItem)
                    {
                        BindingContext = e.SelectedItem as AddressItem
                    });
                }
            };

            Content = listView;
        }

        protected override async void OnAppearing()
        {
            base.OnAppearing();
            listView.ItemsSource = await App.ReportDatabase.GetItemsAsync();
        }
    }
}