﻿using System.ComponentModel;
using SQLite;
using Syncfusion.XForms.DataForm;
namespace DBDraft.Model
{
    public class AddressItem : INotifyPropertyChanged
    {
        public bool ItemChanged = false;
        private string name;
        private string city;
        private int id;
        private int zip;
        private bool complete;
        public AddressItem()
        {
        }

        [PrimaryKey, AutoIncrement]
        [Display(AutoGenerateField = false)]
        public int ID {
            get { return id; }
            set
            {         
                id = value;
                OnPropertyChanged("ID");
            }
        }
        [Display(GroupName = "Name", Order = 0)]
        public string Name {
            get { return name; }
            set
            {
                ItemChanged = (name == value) ? true : false;          
                name = value;
                OnPropertyChanged("Name");
            }
        }

        public string City {
            get { return city; }
            set
            {
                city = value;
                OnPropertyChanged("City");
            }
        }

        public int ZIP {
            get { return zip; }
            set
            {
                zip = value;
                OnPropertyChanged("ZIP");
            }
        }

        public bool Complete {
            get { return complete; }
            set
            {
                complete = value;
                OnPropertyChanged("Complete");
            }
        }


        private string savetoalt;
        [Display(Name = "Save To Alt"), DisplayOptions(ColumnSpan = 2, ShowLabel = true)]
        public string SaveToAlt
        {
            get { return savetoalt; }
            set
            {
                savetoalt = value;
                OnPropertyChanged("SaveToAlt");
            }
        }

        public virtual int SaveToId { get; set; }

        [Display(Name = "Save To"), DisplayOptions(ColumnSpan = 2, ShowLabel = true)]        
        [EnumDataType(typeof(Location))]
        public Location SaveTo
        {
            get { return (Location)SaveToId; }
            set
            {
                SaveToId = (int)value;
                OnPropertyChanged("SaveTo");
            }
        }
        public enum Location
        {
            Sim = 0,
            Phone = 1
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}
